// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

#include "vdt.h"
#include "global.h"
#include "cpart1.h"
#include "cpart2.h"
#include "cpart3.h"
#include "movpart.h"
#include "cpart4.h"
#include "cpart5.h"
#include "cpart6.h"
#include "cpart7.h"
#include "cpart8.h"



//external viariable from global.h
DataLib dl;      //data library
Video      svga;  // svga class
Image      virtscr; // global public virtual screen
DemoEngine de;    // demo engine

int        exitflag=-1;
cpart1     part1;
cpart2     part2;
cpart3     part3;
movpart    moviepart;
cpart4     part4;
cpart5     part5;
cpart6     part6;
cpart7     part7;
cpart8     part8;


// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void check(void){
 if (kbhit())
   if (getch()==27) exitflag=1;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void main(int argv, char* argc[])
 {

	//this demo requires some meory
	de.MemoryRequired = initMemoRequired;
	de.music.autodetect = 0;
	de.music.configDisplay = YES;

        // check for VESA capabilities
        if (svga.Detect(mode_640x480)!=Detected) {
                printf("Sorry, this demo requires a VESA 1.2 compatible SVGA.\n");
                return;
        }


#ifdef datafile
	if (dl.Open("opt-pest.dat")!=Success) {
		printf("missing file: opt-pest.dat\n");
		return;
	}
#endif


        //Add parts. FIRST PART INITIALIZES THE GFX MODE!
	de.AddPart(&part1);     // init, pictures, scroll ghetto
	de.AddPart(&part2);     // tower with star
	de.AddPart(&part7);     // picture
	de.AddPart(&part3);     // hangar with space bikes
	de.AddPart(&part6);     // tunel
	de.AddPart(&part4);     // plasma, zoom
	de.AddPart(&moviepart); // skate movie
	de.AddPart(&part5);     // cubes
	de.AddPart(&part8);     // final pictures

	de.SetSoundtrack("opt-pest.xm");

	// init data in demosystem
        if (de.Init() == Success){
	 //run demo
	 exitflag=0;
         de.Run();
         // deinit
	 de.Done();
	} else
                // deinit
                de.Done();
#ifdef datafile
  dl.Close();
#endif
 if (exitflag==0) {
  printf("Thank you for watching \"Pest\" demo. \n");
  printf("Optik in 2000 for Fiasko'00 \n");
 }
}
