#include "flih.h"

//child from Demopart
class movpart : public DemoPart {
	public:
		movpart() {}
		~movpart() {}

		int Init();
		int Run();
		int Done();
                int Startup();
                int Terminate();
		int Abort() { return Success; }

	private:
		unsigned char      *flidata;       /* Data for .FLI file */
		unsigned            numframes;     /* Frames in animation */
		int                 waitcount;     /* Frames to wait */
		unsigned char      *curptr;        /* Current position in data */
		char                loop;

		void* OpenFLIFile(char const *filename);
		BOOL ReadFLIFrame(FLIFRAME *frame);
		BOOL ProcessFrame(FLIFRAME *frame);
		void PlayFLIAnimation(void);
		void* OpenFLIFilelib(void);

		Image replay;
		Image pestsk;


};


